// $Id: Angle.hh 2125 2007-02-26 19:20:59Z flaterco $

// Angle

/*
    Copyright (C) 1997  David Flater.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

class Angle {
public:
  Angle (); // Creates a zero angle.

  inline Angle (Units::AngleUnits units, double value):
    radians((units == Units::degrees) ? (value * M_PI / 180.0) : value) {}

  inline void operator+= (Angle a) {
    radians += a.radians;
  }

  void operator-= (Angle a);

protected:

  double radians;

  // XTide never needs the actual angle--it only needs the sine or
  // cosine of it.  So if the value is hidden from everything except
  // sin and cos, we can dispense with normalization.
  friend const double sin (Angle a);
  friend const double cos (Angle a);
};

inline const double cos (Angle a) {
  return ::cos (a.radians);
}

inline const Angle operator+ (Angle a, Angle b) {
  a += b;
  return a;
}

// Cleanup2006 Done
